#include "FtpLibrary.h"

STATUS FtpData (FTP *con, char *command , char *file , char *mode)
{
  struct sockaddr_in data, from;
  register struct hostent *host;
  String hostname, cmd;
  int len=sizeof(data), one=1, fromlen=sizeof(from), i, NewSocket;
  char *a, *b;

  CLEAR(data);
  CLEAR(from);
  
  if ( gethostname (hostname, sizeof hostname) == -1 )
    EXIT(con,QUIT,return);
  
  if ((host= (struct hostent *) gethostbyname(hostname)) == 0)
    EXIT(con,QUIT,return);
  
  data.sin_family = host -> h_addrtype;
  
  bcopy (host-> h_addr_list[0], &data.sin_addr, host->h_length);
		
  if ((NewSocket = socket ( AF_INET  , SOCK_STREAM , 0 ))<0)
    EXIT(con,QUIT,return);

  if (setsockopt ( NewSocket, SOL_SOCKET, SO_REUSEADDR,
		   (char *) &one, sizeof one) < 0)
    {
      close (NewSocket);
      EXIT (con,QUIT,return);
    }

  data.sin_port = 0 ;

  if ( bind (NewSocket, (struct sockaddr *) &data, sizeof data) < 0 )
    EXIT(con,QUIT,return);

  if ( getsockname (NewSocket, (struct sockaddr *) &data, &len) < 0 )
    EXIT(con,QUIT,return);

  if ( listen (NewSocket, 1 ) < 0 )
    EXIT(con,QUIT,return);

  a = ( char * ) & data.sin_addr;
  b = ( char * ) & data.sin_port;

  if ( (i = FtpPort(con, CUT(a[0]), CUT(a[1]), CUT(a[2]),
	 	    CUT(a[3]), CUT(b[0]), CUT(b[1]))) < 1 )
    return i;
  
  i = FtpCommand ( con, command, file );
  if ( i < 1 )
    return i;

  if (( con -> datasock = accept (NewSocket, (struct sockaddr *) &from,
                                  &fromlen)) < 0)
    {
      close(NewSocket);
      EXIT(con,QUIT,return);
    }

  close(NewSocket);

  if (mode != (char *) 0)
    {
      con -> datafile = fdopen (con -> datasock, mode);
      con -> ch = EOF;
    }
  
  return i;
}

STATUS FtpOpenRead(FTP *ftp, char *file)
{
  return FtpOpenReadM(ftp,file);
}

STATUS FtpOpenWrite(FTP *ftp, char *file)
{
  return FtpOpenWriteM(ftp,file);
}

STATUS FtpOpenAppend(FTP *ftp, char *file)
{
  return FtpOpenAppendM(ftp,file);
}

STATUS FtpSOpenRead (FTP *ftp, char *file)
{
  return FtpSOpenReadM (ftp,file);
}

STATUS FtpSOpenWrite (FTP *ftp, char *file)
{
  return FtpSOpenWriteM (ftp, file);
}

STATUS FtpSOpenAppend (FTP *ftp, char *file)
{
  return FtpSOpenAppendM (ftp, file);
}
